module:    Test-Utilities-Implementation
author:    Matthias Hlzl (tc@gauss.muc.de)
copyright: Copyright (C) 1996, 1997, 1998 Matthias Hlzl
           Copyright (C) 1998 Way Forward Technologies
version:   0.03 09 Dec 1998
synopsis:  The driver for the test-utilities test-suite.

// Copyright.
// =========

// The driver for the test-utilities test-suite.
// Copyright (C) 1998 Matthias Hlzl.
// Copyright (C) 1998 Way Forward Technologies.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston,
// MA 02111-1307  USA
//
// If you need to receive this program under another license contact
// the author (tc@gauss.muc.de).

define method main 
    (name :: <byte-string>, #rest switches)
 => ();
  if (member?("--test-primitives", switches, test: \=)
	| member?("-p", switches, test: \=))
    say-newline(#t);
    run-primitive-tests();
  end if;

  if (member?("--test-example", switches, test: \=)
	| member?("-e", switches, test: \=))
    say-newline(#t);
    run-testcase(#"normal");
    say-newline(#t);
    run-testcase(#"verbose");
    say-newline(#t);
    run-testcase(#"quiet");
    say-newline(#t);
    run-testcase(#"silent");
  end if;
end method main;

define function run-primitive-tests () => ();
  test-say();
  test-say-line();
  test-say-dots();
  test-say-underlined();
end function run-primitive-tests;

define function test-say () => ();
  say(#t, "Testing say()\n");
  say(#t, "=============\n\n");
  say(#t, "This is a test of say().\n");
  say(#t, "The %= of %= is %=\n", "value", #"i", 123);
  say(#t, "You can include escapes like %=.\n");
  say(#t, "There is ");
  say(#t, "no implicit ");
  say(#t, "linefeed.\n");
  let string = say(#f, "This is output to a string: %=\n", 123);
  say(#t, string);
  say-newline(#t);
end function test-say;

define function test-say-line () => ();
  say-line(#t, "Testing say-line()");
  say-line(#t, "================\n");
  say-line(#t, "This is a line of text printed with say-line().");
  say-line(#t, "This is another %s printed with say-line().",
	   "line of text");
  let string = say(#f, "This is output to a string: %=", 123);
  say-line(#t, string);
  say-line(#t);
end function test-say-line;

define function test-say-dots () => ();
  say-line(#t, "Testing say-dots()");
  say-line(#t, "================\n");
  say-dots(#t, "This is a line");
  say-newline(#t);
  say-dots(#t, "This is %s line, with a number (%=)", "another", 123);
  say-newline(#t);
  let string = say-dots(#f, "This is a string");
  say-line(#t, string);
  let string = say-dots(#f, "This is a string %s %s", "as", "well");
  say-line(#t, string);
  say-newline(#t);
end function test-say-dots;

define function test-say-underlined () => ();
  say-underlined(#t, '=', "Testing say-underlined()");
  say-newline(#t);
  say-underlined(#t, '-', "This is a line");
  say-underlined(#t, '%', "This is another line, with weird underlining");
  say-newline(#t);
end function test-say-underlined;

define function run-testcase (verbosity) => ();
  announce-test-suite("Running the testcase", verbosity: verbosity);
  say-newline(#t);
  announce-section("This is the first section");
  announce("First test");
  say-done();
  announce("Second test fails");
  report-error("The second test failed");
  say-done();
  announce("Third test");
  report-warning("You are warned");
  say-done();
  announce("Fourth test fails");
  report-warning("Told you so");
  report-error("The fourth test failed");
  say-done();
  announce("Fifth test fails expectedly");
  report-expected-error("The fifth test is known to be bad");
  say-done();
  say-intermediate-results();

  announce-section("This is the second section");
  announce("First test");
  say-done();
  announce("Second test");
  say-done();
  say-intermediate-results();

  announce-section("This is the third section");
  announce("First test fails");
  report-error();
  say-done();
  announce("Second test fails");
  report-error("i is %=, should be %=", 1, 0);
  say-done();
  say-intermediate-results();

  say-results();
end function run-testcase;